"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
;
;
var useZIndexModal = function (props) {
    var indexNumberLimit = props.indexNumberLimit, _a = props.prefix, prefix = _a === void 0 ? '' : _a;
    var indexModal = (0, react_1.useCallback)(function (props) {
        var _a = props.selector, selector = _a === void 0 ? '' : _a, _b = props.indexCssVar, indexCssVar = _b === void 0 ? '' : _b, _c = props.indexNum, indexNum = _c === void 0 ? 0 : _c, indexLimit = props.indexLimit;
        var mdSelector = document.querySelectorAll(selector);
        var limitedMdSelector = Array.from(mdSelector).slice(0, indexLimit);
        limitedMdSelector.forEach(function (ms, i) {
            if (ms instanceof HTMLElement) {
                ms.style.cssText += "".concat(indexCssVar, ": ").concat(indexNum + i * 10);
            }
        });
    }, []);
    (0, react_1.useEffect)(function () {
        var modalLength = indexNumberLimit || 3;
        var backdropProps = {
            selector: ".modal-backdrop",
            indexCssVar: "".concat(prefix ? "".concat(prefix, "-backdrop-zindex") : '--bs-backdrop-zindex'),
            indexNum: 1050,
            indexLimit: modalLength
        };
        var modalProps = {
            selector: ".modal.show",
            indexCssVar: "".concat(prefix ? "".concat(prefix, "-modal-zindex") : '--bs-modal-zindex'),
            indexNum: 1055,
            indexLimit: modalLength
        };
        var setTimeOut = setTimeout(function () {
            indexModal(backdropProps);
            indexModal(modalProps);
        }, 10);
        return function () {
            clearTimeout(setTimeOut);
        };
    }, [indexNumberLimit, prefix, indexModal]);
};
exports.default = useZIndexModal;
